Index: doc/references.bib
===================================================================
--- doc/references.bib	(revision 743)
+++ doc/references.bib	(revision 743)
@@ -0,0 +1,341 @@
+%%%%% Defining LEMON %%%%%
+
+@misc{lemon,
+  key =          {LEMON},
+  title =        {{LEMON} -- {L}ibrary for {E}fficient {M}odeling and
+                  {O}ptimization in {N}etworks},
+  howpublished = {\url{http://lemon.cs.elte.hu/}},
+  year =         2009
+}
+
+@misc{egres,
+  key =          {EGRES},
+  title =        {{EGRES} -- {E}gerv{\'a}ry {R}esearch {G}roup on
+                  {C}ombinatorial {O}ptimization},
+  howpublished = {\url{http://www.cs.elte.hu/egres/}},
+  year =         2009
+}
+
+@misc{coinor,
+  key =          {COIN-OR},
+  title =        {{COIN-OR} -- {C}omputational {I}nfrastructure for
+                  {O}perations {R}esearch},
+  howpublished = {\url{http://www.coin-or.org/}},
+  year =         2009
+}
+
+
+%%%%% Other libraries %%%%%%
+
+@misc{boost,
+  key =          {Boost},
+  title =        {{B}oost {C++} {L}ibraries},
+  howpublished = {\url{http://www.boost.org/}},
+  year =         2009
+}
+
+@book{bglbook,
+  author =       {Jeremy G. Siek and Lee-Quan Lee and Andrew
+                  Lumsdaine},
+  title =        {The Boost Graph Library: User Guide and Reference
+                  Manual},
+  publisher =    {Addison-Wesley},
+  year =         2002
+}
+
+@misc{leda,
+  key =          {LEDA},
+  title =        {{LEDA} -- {L}ibrary of {E}fficient {D}ata {T}ypes and
+                  {A}lgorithms},
+  howpublished = {\url{http://www.algorithmic-solutions.com/}},
+  year =         2009
+}
+
+@book{ledabook,
+  author =       {Kurt Mehlhorn and Stefan N{\"a}her},
+  title =        {{LEDA}: {A} platform for combinatorial and geometric
+                  computing},
+  isbn =         {0-521-56329-1},
+  publisher =    {Cambridge University Press},
+  address =      {New York, NY, USA},
+  year =         1999
+}
+
+
+%%%%% Tools that LEMON depends on %%%%%
+
+@misc{cmake,
+  key =          {CMake},
+  title =        {{CMake} -- {C}ross {P}latform {M}ake},
+  howpublished = {\url{http://www.cmake.org/}},
+  year =         2009
+}
+
+@misc{doxygen,
+  key =          {Doxygen},
+  title =        {{Doxygen} -- {S}ource code documentation generator
+                  tool},
+  howpublished = {\url{http://www.doxygen.org/}},
+  year =         2009
+}
+
+
+%%%%% LP/MIP libraries %%%%%
+
+@misc{glpk,
+  key =          {GLPK},
+  title =        {{GLPK} -- {GNU} {L}inear {P}rogramming {K}it},
+  howpublished = {\url{http://www.gnu.org/software/glpk/}},
+  year =         2009
+}
+
+@misc{clp,
+  key =          {Clp},
+  title =        {{Clp} -- {Coin-Or} {L}inear {P}rogramming},
+  howpublished = {\url{http://projects.coin-or.org/Clp/}},
+  year =         2009
+}
+
+@misc{cbc,
+  key =          {Cbc},
+  title =        {{Cbc} -- {Coin-Or} {B}ranch and {C}ut},
+  howpublished = {\url{http://projects.coin-or.org/Cbc/}},
+  year =         2009
+}
+
+@misc{cplex,
+  key =          {CPLEX},
+  title =        {{ILOG} {CPLEX}},
+  howpublished = {\url{http://www.ilog.com/}},
+  year =         2009
+}
+
+@misc{soplex,
+  key =          {SoPlex},
+  title =        {{SoPlex} -- {T}he {S}equential {O}bject-{O}riented
+                  {S}implex},
+  howpublished = {\url{http://soplex.zib.de/}},
+  year =         2009
+}
+
+
+%%%%% General books %%%%%
+
+@book{amo93networkflows,
+  author =       {Ravindra K. Ahuja and Thomas L. Magnanti and James
+                  B. Orlin},
+  title =        {Network Flows: Theory, Algorithms, and Applications},
+  publisher =    {Prentice-Hall, Inc.},
+  year =         1993,
+  month =        feb,
+  isbn =         {978-0136175490}
+}
+
+@book{schrijver03combinatorial,
+  author =       {Alexander Schrijver},
+  title =        {Combinatorial Optimization: Polyhedra and Efficiency},
+  publisher =    {Springer-Verlag},
+  year =         2003,
+  isbn =         {978-3540443896}
+}
+
+@book{clrs01algorithms,
+  author =       {Thomas H. Cormen and Charles E. Leiserson and Ronald
+                  L. Rivest and Clifford Stein},
+  title =        {Introduction to Algorithms},
+  publisher =    {The MIT Press},
+  year =         2001,
+  edition =      {2nd}
+}
+
+@book{stroustrup00cpp,
+  author =       {Bjarne Stroustrup},
+  title =        {The C++ Programming Language},
+  edition =      {3rd},
+  publisher =    {Addison-Wesley Professional},
+  isbn =         0201700735,
+  month =        {February},
+  year =         2000
+}
+
+
+%%%%% Maximum flow algorithms %%%%%
+
+@inproceedings{goldberg86newapproach,
+  author =       {Andrew V. Goldberg and Robert E. Tarjan},
+  title =        {A new approach to the maximum flow problem},
+  booktitle =    {STOC '86: Proceedings of the Eighteenth Annual ACM
+                  Symposium on Theory of Computing},
+  year =         1986,
+  publisher =    {ACM Press},
+  address =      {New York, NY},
+  pages =        {136-146}
+}
+
+@article{dinic70algorithm,
+  author =       {E. A. Dinic},
+  title =        {Algorithm for solution of a problem of maximum flow
+                  in a network with power estimation},
+  journal =      {Soviet Math. Doklady},
+  year =         1970,
+  volume =       11,
+  pages =        {1277-1280}
+}
+
+@article{goldberg08partial,
+  author =       {Andrew V. Goldberg},
+  title =        {The Partial Augment-Relabel Algorithm for the
+                  Maximum Flow Problem},
+  journal =      {16th Annual European Symposium on Algorithms},
+  year =         2008,
+  pages =        {466-477}
+}
+
+@article{sleator83dynamic,
+  author =       {Daniel D. Sleator and Robert E. Tarjan},
+  title =        {A data structure for dynamic trees},
+  journal =      {Journal of Computer and System Sciences},
+  year =         1983,
+  volume =       26,
+  number =       3,
+  pages =        {362-391}
+}
+
+
+%%%%% Minimum mean cycle algorithms %%%%%
+
+@article{karp78characterization,
+  author =       {Richard M. Karp},
+  title =        {A characterization of the minimum cycle mean in a
+                  digraph},
+  journal =      {Discrete Math.},
+  year =         1978,
+  volume =       23,
+  pages =        {309-311}
+}
+
+@article{dasdan98minmeancycle,
+  author =       {Ali Dasdan and Rajesh K. Gupta},
+  title =        {Faster Maximum and Minimum Mean Cycle Alogrithms for
+                  System Performance Analysis},
+  journal =      {IEEE Transactions on Computer-Aided Design of
+                  Integrated Circuits and Systems},
+  year =         1998,
+  volume =       17,
+  number =       10,
+  pages =        {889-899}
+}
+
+
+%%%%% Minimum cost flow algorithms %%%%%
+
+@article{klein67primal,
+  author =       {Morton Klein},
+  title =        {A primal method for minimal cost flows with
+                  applications to the assignment and transportation
+                  problems},
+  journal =      {Management Science},
+  year =         1967,
+  volume =       14,
+  pages =        {205-220}
+}
+
+@inproceedings{goldberg88cyclecanceling,
+  author =       {Andrew V. Goldberg and Robert E. Tarjan},
+  title =        {Finding minimum-cost circulations by canceling
+                  negative cycles},
+  booktitle =    {STOC '88: Proceedings of the Twentieth Annual ACM
+                  Symposium on Theory of Computing},
+  year =         1988,
+  publisher =    {ACM Press},
+  address =      {New York, NY},
+  pages =        {388-397}
+}
+
+@article{edmondskarp72theoretical,
+  author =       {Jack Edmonds and Richard M. Karp},
+  title =        {Theoretical improvements in algorithmic efficiency
+                  for network flow problems},
+  journal =      {Journal of the ACM},
+  year =         1972,
+  volume =       19,
+  number =       2,
+  pages =        {248-264}
+}
+
+@inproceedings{goldberg87approximation,
+  author =       {Andrew V. Goldberg and Robert E. Tarjan},
+  title =        {Solving minimum-cost flow problems by successive
+                  approximation},
+  booktitle =    {STOC '87: Proceedings of the Nineteenth Annual ACM
+                  Symposium on Theory of Computing},
+  year =         1987,
+  publisher =    {ACM Press},
+  address =      {New York, NY},
+  pages =        {7-18}
+}
+
+@article{goldberg90finding,
+  author =       {Andrew V. Goldberg and Robert E. Tarjan},
+  title =        {Finding Minimum-Cost Circulations by Successive
+                  Approximation},
+  journal =      {Mathematics of Operations Research},
+  year =         1990,
+  volume =       15,
+  number =       3,
+  pages =        {430-466}
+}
+
+@article{goldberg97efficient,
+  author =       {Andrew V. Goldberg},
+  title =        {An Efficient Implementation of a Scaling
+                  Minimum-Cost Flow Algorithm},
+  journal =      {Journal of Algorithms},
+  year =         1997,
+  volume =       22,
+  number =       1,
+  pages =        {1-29}
+}
+
+@article{bunnagel98efficient,
+  author =       {Ursula B{\"u}nnagel and Bernhard Korte and Jens
+                  Vygen},
+  title =        {Efficient implementation of the {G}oldberg-{T}arjan
+                  minimum-cost flow algorithm},
+  journal =      {Optimization Methods and Software},
+  year =         1998,
+  volume =       10,
+  pages =        {157-174}
+}
+
+@mastersthesis{kellyoneill91netsimplex,
+  author =       {Damian J. Kelly and Garrett M. O'Neill},
+  title =        {The Minimum Cost Flow Problem and The Network
+                  Simplex Method},
+  school =       {University College},
+  address =      {Dublin, Ireland},
+  year =         1991,
+  month =        sep,
+}
+
+@techreport{lobel96networksimplex,
+  author =       {Andreas L{\"o}bel},
+  title =        {Solving large-scale real-world minimum-cost flow
+                  problems by a network simplex method},
+  institution =  {Konrad-Zuse-Zentrum fur Informationstechnik Berlin
+                  ({ZIB})},
+  address =      {Berlin, Germany},
+  year =         1996,
+  number =       {SC 96-7}
+}
+
+@article{frangioni06computational,
+  author =       {Antonio Frangioni and Antonio Manca},
+  title =        {A Computational Study of Cost Reoptimization for
+                  Min-Cost Flow Problems},
+  journal =      {INFORMS Journal On Computing},
+  year =         2006,
+  volume =       18,
+  number =       1,
+  pages =        {61-70}
+}