Index: Makefile.am
===================================================================
--- Makefile.am	(revision 752)
+++ Makefile.am	(revision 629)
@@ -18,5 +18,4 @@
 	cmake/FindGLPK.cmake \
 	cmake/FindCOIN.cmake \
-	cmake/LEMONConfig.cmake.in \
 	cmake/version.cmake.in \
 	cmake/version.cmake \
Index: doc/references.bib
===================================================================
--- doc/references.bib	(revision 743)
+++ doc/references.bib	(revision 754)
@@ -13,6 +13,5 @@
   title =        {{EGRES} -- {E}gerv{\'a}ry {R}esearch {G}roup on
                   {C}ombinatorial {O}ptimization},
-  howpublished = {\url{http://www.cs.elte.hu/egres/}},
-  year =         2009
+  url =          {http://www.cs.elte.hu/egres/}
 }
 
@@ -21,6 +20,5 @@
   title =        {{COIN-OR} -- {C}omputational {I}nfrastructure for
                   {O}perations {R}esearch},
-  howpublished = {\url{http://www.coin-or.org/}},
-  year =         2009
+  url =          {http://www.coin-or.org/}
 }
 
@@ -31,6 +29,5 @@
   key =          {Boost},
   title =        {{B}oost {C++} {L}ibraries},
-  howpublished = {\url{http://www.boost.org/}},
-  year =         2009
+  url =          {http://www.boost.org/}
 }
 
@@ -48,6 +45,5 @@
   title =        {{LEDA} -- {L}ibrary of {E}fficient {D}ata {T}ypes and
                   {A}lgorithms},
-  howpublished = {\url{http://www.algorithmic-solutions.com/}},
-  year =         2009
+  url =          {http://www.algorithmic-solutions.com/}
 }
 
@@ -68,6 +64,5 @@
   key =          {CMake},
   title =        {{CMake} -- {C}ross {P}latform {M}ake},
-  howpublished = {\url{http://www.cmake.org/}},
-  year =         2009
+  url =          {http://www.cmake.org/}
 }
 
@@ -76,6 +71,5 @@
   title =        {{Doxygen} -- {S}ource code documentation generator
                   tool},
-  howpublished = {\url{http://www.doxygen.org/}},
-  year =         2009
+  url =          {http://www.doxygen.org/}
 }
 
@@ -86,6 +80,5 @@
   key =          {GLPK},
   title =        {{GLPK} -- {GNU} {L}inear {P}rogramming {K}it},
-  howpublished = {\url{http://www.gnu.org/software/glpk/}},
-  year =         2009
+  url =          {http://www.gnu.org/software/glpk/}
 }
 
@@ -93,6 +86,5 @@
   key =          {Clp},
   title =        {{Clp} -- {Coin-Or} {L}inear {P}rogramming},
-  howpublished = {\url{http://projects.coin-or.org/Clp/}},
-  year =         2009
+  url =          {http://projects.coin-or.org/Clp/}
 }
 
@@ -100,6 +92,5 @@
   key =          {Cbc},
   title =        {{Cbc} -- {Coin-Or} {B}ranch and {C}ut},
-  howpublished = {\url{http://projects.coin-or.org/Cbc/}},
-  year =         2009
+  url =          {http://projects.coin-or.org/Cbc/}
 }
 
@@ -107,6 +98,5 @@
   key =          {CPLEX},
   title =        {{ILOG} {CPLEX}},
-  howpublished = {\url{http://www.ilog.com/}},
-  year =         2009
+  url =          {http://www.ilog.com/}
 }
 
@@ -115,6 +105,5 @@
   title =        {{SoPlex} -- {T}he {S}equential {O}bject-{O}riented
                   {S}implex},
-  howpublished = {\url{http://soplex.zib.de/}},
-  year =         2009
+  url =          {http://soplex.zib.de/}
 }
 
Index: lemon/path.h
===================================================================
--- lemon/path.h	(revision 751)
+++ lemon/path.h	(revision 559)
@@ -1016,18 +1016,16 @@
   /// \brief The source of a path
   ///
-  /// This function returns the source node of the given path.
-  /// If the path is empty, then it returns \c INVALID.
+  /// This function returns the source of the given path.
   template <typename Digraph, typename Path>
   typename Digraph::Node pathSource(const Digraph& digraph, const Path& path) {
-    return path.empty() ? INVALID : digraph.source(path.front());
+    return digraph.source(path.front());
   }
 
   /// \brief The target of a path
   ///
-  /// This function returns the target node of the given path.
-  /// If the path is empty, then it returns \c INVALID.
+  /// This function returns the target of the given path.
   template <typename Digraph, typename Path>
   typename Digraph::Node pathTarget(const Digraph& digraph, const Path& path) {
-    return path.empty() ? INVALID : digraph.target(path.back());
+    return digraph.target(path.back());
   }
 
Index: scripts/bib2dox.py
===================================================================
--- scripts/bib2dox.py	(revision 745)
+++ scripts/bib2dox.py	(revision 754)
@@ -71,5 +71,5 @@
 author_rex = re.compile('\s+and\s+')
 rembraces_rex = re.compile('[{}]')
-capitalize_rex = re.compile('({\w*})')
+capitalize_rex = re.compile('({[^}]*})')
 
 # used by bibtexkeywords(data)
@@ -364,4 +364,6 @@
             if entrycont.has_key('note') and (entrycont['note'] != ''):
                 entry.append(entrycont['note'] + '.')
+            if entrycont.has_key('url') and (entrycont['url'] != ''):
+                entry.append(entrycont['url'] + '.')
 
             # generate keys for sorting and for the output
@@ -411,4 +413,7 @@
                 field = string.lower(field)
                 data =  data_rex.sub('\g<2>', line)
+
+            if field == 'url':
+                data = '\\url{' + data.strip() + '}'
             
             if field in ('author', 'editor'):