Index: src/work/marci/iterator_bfs_demo.cc
===================================================================
--- src/work/marci/iterator_bfs_demo.cc	(revision 774)
+++ src/work/marci/iterator_bfs_demo.cc	(revision 777)
@@ -10,4 +10,5 @@
 
 using namespace hugo;
+
 using std::cout; 
 using std::endl;
@@ -73,19 +74,4 @@
   cout << "    \\-->    ------------->         "<< endl;
   
-//   typedef TrivGraphWrapper<const Graph> CGW;
-//   CGW gw(G);
-
-//   cout << "bfs and dfs demo on the directed graph" << endl;
-//   for(CGW::NodeIt n=gw.first<CGW::NodeIt>(); n.valid(); ++n) { 
-//     cout << n << ": ";
-//     cout << "out edges: ";
-//     for(CGW::OutEdgeIt e=gw.first<CGW::OutEdgeIt>(n); e.valid(); ++e) 
-//       cout << e << " ";
-//     cout << "in edges: ";
-//     for(CGW::InEdgeIt e=gw.first<CGW::InEdgeIt>(n); e.valid(); ++e) 
-//       cout << e << " ";
-//     cout << endl;
-//   }
-
   {
     EdgeNameMap< Graph, Graph::NodeMap<string> > edge_name(G, node_name);
@@ -108,5 +94,5 @@
     while (!bfs.finished()) {
       //cout << "edge: ";
-      if (Graph::Edge(Graph::OutEdgeIt(bfs))!=INVALID) {
+      if (Graph::Edge(bfs)!=INVALID) {
 	cout << edge_name[bfs] << /*endl*/", " << 
 	  node_name[G.tail(bfs)] << 
@@ -117,5 +103,5 @@
       } else { 
 	cout << "invalid" << /*endl*/", " << 
-	  node_name[bfs.aNode()] << 
+	  node_name[bfs.tail()] << 
 	  (bfs.isANodeExamined() ? ": is examined, " : ": is not examined, ") << 
 	  
@@ -142,5 +128,5 @@
       ++dfs;
       //cout << "edge: ";
-      if (Graph::Edge(Graph::OutEdgeIt(dfs))!=INVALID) {
+      if (Graph::Edge(dfs)!=INVALID) {
 	cout << edge_name[dfs] << /*endl*/", " << 
 	  node_name[G.tail(dfs)] << 
@@ -151,5 +137,5 @@
       } else { 
 	cout << "invalid" << /*endl*/", " << 
-	  node_name[dfs.aNode()] << 
+	  node_name[dfs.tail()] << 
 	  (dfs.isANodeExamined() ? ": is examined, " : ": is not examined, ") << 
 	  
@@ -184,6 +170,6 @@
     while (!bfs.finished()) {
       //cout << "edge: ";
-      if (GW::Edge(GW::OutEdgeIt(bfs))!=INVALID) {
-	cout << edge_name[GW::OutEdgeIt(bfs)] << /*endl*/", " << 
+      if (GW::Edge(bfs)!=INVALID) {
+	cout << edge_name[GW::Edge(bfs)] << /*endl*/", " << 
 	  node_name[gw.tail(bfs)] << 
 	  (bfs.isANodeExamined() ? ": is examined, " : ": is not examined, ") << 
@@ -193,5 +179,5 @@
       } else { 
 	cout << "invalid" << /*endl*/", " << 
-	  node_name[bfs.aNode()] << 
+	  node_name[bfs.tail()] << 
 	  (bfs.isANodeExamined() ? ": is examined, " : ": is not examined, ") << 
 	  
@@ -218,6 +204,6 @@
       ++dfs;
       //cout << "edge: ";
-      if (GW::OutEdgeIt(dfs)!=INVALID) {
-	cout << edge_name[GW::OutEdgeIt(dfs)] << /*endl*/", " << 
+      if (GW::Edge(dfs)!=INVALID) {
+	cout << edge_name[GW::Edge(dfs)] << /*endl*/", " << 
 	  node_name[gw.tail(dfs)] << 
 	  (dfs.isANodeExamined() ? ": is examined, " : ": is not examined, ") << 
@@ -227,5 +213,5 @@
       } else { 
 	cout << "invalid" << /*endl*/", " << 
-	  node_name[dfs.aNode()] << 
+	  node_name[dfs.tail()] << 
 	  (dfs.isANodeExamined() ? ": is examined, " : ": is not examined, ") << 
 	  
@@ -347,6 +333,6 @@
     while (!bfs.finished()) {
       //cout << "edge: ";
-      if (GW::OutEdgeIt(bfs)!=INVALID) {
-	cout << edge_name[GW::OutEdgeIt(bfs)] << /*endl*/", " << 
+      if (GW::Edge(bfs)!=INVALID) {
+	cout << edge_name[GW::Edge(bfs)] << /*endl*/", " << 
 	  node_name[gw.tail(bfs)] << 
 	  (bfs.isANodeExamined() ? ": is examined, " : ": is not examined, ") << 
@@ -356,5 +342,5 @@
       } else { 
 	cout << "invalid" << /*endl*/", " << 
-	  node_name[bfs.aNode()] << 
+	  node_name[bfs.tail()] << 
 	  (bfs.isANodeExamined() ? ": is examined, " : ": is not examined, ") << 
 	  
@@ -381,6 +367,6 @@
       ++dfs;
       //cout << "edge: ";
-      if (GW::OutEdgeIt(dfs)!=INVALID) {
-	cout << edge_name[GW::OutEdgeIt(dfs)] << /*endl*/", " << 
+      if (GW::Edge(dfs)!=INVALID) {
+	cout << edge_name[GW::Edge(dfs)] << /*endl*/", " << 
 	  node_name[gw.tail(dfs)] << 
 	  (dfs.isANodeExamined() ? ": is examined, " : ": is not examined, ") << 
@@ -390,5 +376,5 @@
       } else { 
 	cout << "invalid" << /*endl*/", " << 
-	  node_name[dfs.aNode()] << 
+	  node_name[dfs.tail()] << 
 	  (dfs.isANodeExamined() ? ": is examined, " : ": is not examined, ") << 
 	  